functor MkSeqPackedParenMatch (structure Seq : SEQUENCE)
  :> PACKED_PAREN_MATCH where type 'a seq = 'a Seq.t =
struct
  type 'a seq = 'a Seq.t

  fun parenMatch (parens : Paren.Pack.t Seq.t) : bool =
    let
      (* TODO: using (i,j) representation of counter is faster, due to
       * one fewer case statement *)
      (*fun adjustCounter (x, p) =
        case x of
          NONE => NONE
        | SOME c =>
            case p of
              Paren.L => SOME (c+1)
            | Paren.R => if c = 0 then NONE else SOME (c-1)

      fun adjustCounter' (x, ps) = Paren.Pack.iterate adjustCounter x ps*)

      fun extendParen ((i,j), p) =
        case p of
          Paren.L => (i, j+1)
        | Paren.R => if j = 0 then (i+1, j) else (i, j-1)

      fun extendPack ((i,j), ps) = Paren.Pack.iterate extendParen (i,j) ps
    in
      Seq.iterate extendPack (0, 0) parens = (0, 0)
      (*Seq.iterate adjustCounter' (SOME 0) parens = SOME 0*)
    end

end
