functor MkSeqParenMatch (structure Seq : SEQUENCE)
  :> PAREN_MATCH where type 'a seq = 'a Seq.t =
struct
  type 'a seq = 'a Seq.t

  fun parenMatch (parens : Paren.t Seq.t) : bool =
    let
      (* TODO: using (i,j) representation of counter is faster, due to
       * one fewer case statement *)
      (*fun adjustCounter (x, p) =
        case x of
          NONE => NONE
        | SOME c =>
            case p of
              Paren.L => SOME (c+1)
            | Paren.R => if c = 0 then NONE else SOME (c-1)*)

      fun extend ((i,j), p) =
        case p of
          Paren.L => (i, j+1)
        | Paren.R => if j = 0 then (i+1, j) else (i, j-1)

    in
      Seq.iterate extend (0, 0) parens = (0, 0)
      (*Seq.iterate adjustCounter (SOME 0) parens = SOME 0*)
    end

end
