#!/usr/bin/python

import sys
import subprocess

args = sys.argv[1:]

try:
  i = args.index("-proc")
  nprocs = args[i+1]
  args = args[:i] + args[(i+2):]
except ValueError:
  nprocs = "1"

try:
  i = args.index("-exec")
  executable = args[i+1]
  args = args[:i] + args[(i+2):]
except ValueError:
  executable = "./alg.fj"

cmd = ' '.join([executable, "@MLton", "number-processors", nprocs, "--"] + args)
# print cmd
sys.exit(subprocess.call(cmd, shell=True))
